unit fPositionAppMainForm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Inifiles,
  LazLogger;

type

  { TFMainForm }

  TFMainForm = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure Label1Click(Sender: TObject);
  private
    function GetCfgFilename: string;
  public
    PositionIni : TMemInifile;
    PositionTop,
    PositionLeft,
    AppWidth,
    AppHeight :Integer;
    HintMessage: String;

  end;

var
  FMainForm: TFMainForm;

implementation

{$R *.lfm}



{ TFMainForm }
procedure TFMainForm.FormCreate(Sender: TObject);
var
  r: TRect;
begin
  //PositionIni      := TMemInifile.Create(extractfilepath(application.exename) +'PositionIni.ini');
  PositionIni      := TMemInifile.Create(GetCfgFilename);

  PositionTop      := PositionIni.ReadInteger('SETTINGS', 'Top', PositionTop) ;
  PositionLeft     := PositionIni.ReadInteger('SETTINGS', 'Left',PositionLeft) ;

  AppWidth         := PositionIni.ReadInteger('SETTINGS', 'Width', AppWidth) ;
  AppHeight        := PositionIni.ReadInteger('SETTINGS', 'Height', AppHeight) ;

  r:=Screen.WorkAreaRect;
  if (PositionLeft<r.Left) or (PositionTop<r.Top)
      or (PositionLeft+AppWidth>r.Right)
      or (PositionTop+AppHeight>r.Bottom) then
  begin
    // outside of screen, using default
    //ShowMessage('AAA1 '+dbgs(PositionLeft)+' '+dbgs(r));
  end else
    FMainForm.SetBounds(PositionLeft,PositionTop,AppWidth,AppHeight);
  //ShowMessage('AAA2 '+dbgs(PositionLeft)+' '+dbgs(r)+' Cur='+dbgs(BoundsRect));
end;

procedure TFMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  PositionTop := FMainForm.Top;
  PositionLeft:= FMainForm.Left;

  AppWidth    := FMainForm.Width;
  AppHeight   := FMainForm.Height;

  PositionIni.WriteInteger('SETTINGS', 'Top',  PositionTop);
  PositionIni.WriteInteger('SETTINGS', 'Left', PositionLeft);

  PositionIni.WriteInteger('SETTINGS', 'Width', AppWidth);
  PositionIni.WriteInteger('SETTINGS', 'Height', AppHeight);

  PositionIni.UpdateFile;
  PositionIni.Free  ;
end;

procedure TFMainForm.Button1Click(Sender: TObject);
begin
  Label1.Visible:= True ;
end;

procedure TFMainForm.FormDestroy(Sender: TObject);
begin
 // PositionIni.free;
end;

procedure TFMainForm.Label1Click(Sender: TObject);
Var PT,Pl,AW,AH : String;
  Hintstring: String;
begin

 PositionTop := FMainForm.Top;
 PositionLeft:= FMainForm.Left;

 AppWidth    := FMainForm.Width;
 AppHeight   := FMainForm.Height;

 PositionIni.WriteInteger('SETTINGS', 'Top',  PositionTop);
 PositionIni.WriteInteger('SETTINGS', 'Left', PositionLeft);

 PositionIni.WriteInteger('SETTINGS', 'Width', AppWidth);
 PositionIni.WriteInteger('SETTINGS', 'Height', AppHeight);

 PositionIni.UpdateFile;
 PositionTop   := PositionIni.ReadInteger('SETTINGS', 'Top', PositionTop) ;
 PositionLeft  := PositionIni.ReadInteger('SETTINGS', 'Left',PositionLeft) ;

 AppWidth      := PositionIni.ReadInteger('SETTINGS', 'Width', AppWidth) ;
 AppHeight     := PositionIni.ReadInteger('SETTINGS', 'Height', AppHeight) ;

 PT :=  IntTostr(PositionTop);
 PL :=  IntTostr(PositionLeft);
 AW :=  IntTostr(AppWidth);
 AH :=  IntTostr(AppHeight);

 Hintstring := 'Top' + ' ' + PT + ' ' + 'Left' + ' ' + PL + ' ' + 'Width' + ' ' + AW + ' '+'Hight' + ' ' + AH;

 Label1.Hint:= Hintstring;

 showmessage(Hintstring);


end;

function TFMainForm.GetCfgFilename: string;
{$IFDEF darwin}
var
  p: SizeInt;
{$ENDIF}
begin
  {$IFDEF darwin}
  Result := extractfilepath(application.ExeName);
  p:=pos('.app/Contents/MacOS/',Result);
  if p>0 then
    Result:=ExtractFilePath(LeftStr(Result,p-1));
  {$ELSE}
  Result:=ExtractFilePath(Application.ExeName);
  {$ENDIF}
  Result:=Result+'PositionIni.ini';
end;

end.

